Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.awt.geom
Class Rectangle2D

    java.lang.Object
      |
      +--java.awt.geom.RectangularShape
            |
            +--java.awt.geom.Rectangle2D

All Implemented Interfaces:
  Cloneable, Shape

Direct Known Subclasses:
  Rectangle, Rectangle2D.Double, Rectangle2D.Float

public abstract class Rectangle2D
extends RectangularShape

The `Rectangle2D` class describes a rectangle defined by a location (x, y) and dimension (w x h).

This class is only the abstract superclass for all objects that store a 2D rectangle. The actual storage representation of the coordinates is left to the subclass.

Inner Class Summary
`static class` | `Rectangle2D.Double` The `Double` class defines a rectangle specified in double coordinates.
`static class` | `Rectangle2D.Float` The `Float` class defines a rectangle specified in float coordinates.

Field Summary
`static int` | `OUT_BOTTOM` The bitmask that indicates that a point lies below this `Rectangle2D`.
`static int` | `OUT_LEFT` The bitmask that indicates that a point lies to the left of this `Rectangle2D`.
`static int` | `OUT_RIGHT` The bitmask that indicates that a point lies to the right of this `Rectangle2D`.
`static int` | `OUT_TOP` The bitmask that indicates that a point lies above this `Rectangle2D`.

Constructor Summary
`protected` | `Rectangle2D()` This is an abstract class that cannot be instantiated directly.

Method Summary
`void` | `add(double newx, double newy)` Adds a point, specified by the double precision arguments `newx` and `newy`, to this `Rectangle2D`.
`void` | `add(Point2D pt)` Adds the `Point2D` object `pt` to this `Rectangle2D`.
`void` | `add(Rectangle2D r)` Adds a `Rectangle2D` object to this `Rectangle2D`.
`boolean` | `contains(double x, double y)` Tests if a specified coordinate is inside the boundary of this `Rectangle2D`.
`boolean` | `contains(double x, double y, double w, double h)` Tests if the interior of this `Rectangle2D` entirely contains the specified set of rectangular coordinates.
`abstract Rectangle2D` | `createIntersection(Rectangle2D r)` Returns a new `Rectangle2D` object representing the intersection of this `Rectangle2D` with the specified `Rectangle2D`.
`abstract Rectangle2D` | `createUnion(Rectangle2D r)` Returns a new `Rectangle2D` object representing the union of this `Rectangle2D` with the specified `Rectangle2D`.
`boolean` | `equals(Object obj)` Determines whether or not the specified `Object` is equal to this `Rectangle2D`.
`Rectangle2D` | `getBounds2D()` Returns the high precision bounding box of this `Rectangle2D`.
`PathIterator` | `getPathIterator(AffineTransform at)` Returns an iteration object that defines the boundary of this `Rectangle2D`.
`PathIterator` | `getPathIterator(AffineTransform at, double flatness)` Returns an iteration object that defines the boundary of the flattened `Rectangle2D`.
`int` | `hashCode()` Returns the hashcode for this `Rectangle2D`.
`static void` | `intersect(Rectangle2D src1, Rectangle2D src2, Rectangle2D dest)` Intersects the pair of specified source `Rectangle2D` objects and puts the result into the specified destination `Rectangle2D` object.
`boolean` | `intersects(double x, double y, double w, double h)` Tests if the interior of this `Rectangle2D` intersects the interior of a specified set of rectangular coordinates.
`boolean` | `intersectsLine(double x1, double y1, double x2, double y2)` Tests if the specified line segment intersects the interior of this `Rectangle2D`.
`boolean` | `intersectsLine(Line2D l)` Tests if the specified line segment intersects the interior of this `Rectangle2D`.
`abstract int` | `outcode(double x, double y)` Determines where the specified coordinates lie with respect to this `Rectangle2D`.
`int` | `outcode(Point2D p)` Determines where the specified `Point2D` lies with respect to this `Rectangle2D`.
`void` | `setFrame(double x, double y, double w, double h)` Sets the location and size of the outer bounds of this `Rectangle2D` to the specified rectangular values.
`abstract void` | `setRect(double x, double y, double w, double h)` Sets the location and size of this `Rectangle2D` to the specified double values.
`void` | `setRect(Rectangle2D r)` Sets this `Rectangle2D` to be the same as the specified `Rectangle2D`.
`static void` | `union(Rectangle2D src1, Rectangle2D src2, Rectangle2D dest)` Unions the pair of source `Rectangle2D` objects and puts the result into the specified destination `Rectangle2D` object.

Methods inherited from class java.awt.geom.RectangularShape
`clone, contains, contains, getBounds, getCenterX, getCenterY, getFrame, getHeight, getMaxX, getMaxY, getMinX, getMinY, getWidth, getX, getY, intersects, isEmpty, setFrame, setFrame, setFrameFromCenter, setFrameFromCenter, setFrameFromDiagonal, setFrameFromDiagonal`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### OUT_LEFT

    public static final int OUT_LEFT

  The bitmask that indicates that a point lies to the left of this `Rectangle2D`.
  Since:
    1.2

### OUT_TOP

    public static final int OUT_TOP

  The bitmask that indicates that a point lies above this `Rectangle2D`.
  Since:
    1.2

### OUT_RIGHT

    public static final int OUT_RIGHT

  The bitmask that indicates that a point lies to the right of this `Rectangle2D`.
  Since:
    1.2

### OUT_BOTTOM

    public static final int OUT_BOTTOM

  The bitmask that indicates that a point lies below this `Rectangle2D`.
  Since:
    1.2

Constructor Detail

### Rectangle2D

    protected Rectangle2D()

  This is an abstract class that cannot be instantiated directly. Type-specific implementation subclasses are available for instantiation and provide a number of formats for storing the information necessary to satisfy the various accessor methods below.
  See Also:
    `Rectangle2D.Float`, `Rectangle2D.Double`, `Rectangle`

Method Detail

### setRect

    public abstract void setRect(double x,
                                 double y,
                                 double w,
                                 double h)

  Sets the location and size of this `Rectangle2D` to the specified double values.
  Parameters:
    `x, y` - the coordinates to which to set the location of the upper left corner of this `Rectangle2D`
    `w` - the value to use to set the width of this `Rectangle2D`
    `h` - the value to use to set the height of this `Rectangle2D`
  Since:
    1.2

### setRect

    public void setRect(Rectangle2D r)

  Sets this `Rectangle2D` to be the same as the specified `Rectangle2D`.
  Parameters:
    `r` - the specified `Rectangle2D`
  Since:
    1.2

### intersectsLine

    public boolean intersectsLine(double x1,
                                  double y1,
                                  double x2,
                                  double y2)

  Tests if the specified line segment intersects the interior of this `Rectangle2D`.
  Parameters:
    `x1, y1` - the first endpoint of the specified line segment
    `x2, y2` - the second endpoint of the specified line segment
  Returns:
    `true` if the specified line segment intersects the interior of this `Rectangle2D`; `false` otherwise.
  Since:
    1.2

### intersectsLine

    public boolean intersectsLine(Line2D l)

  Tests if the specified line segment intersects the interior of this `Rectangle2D`.
  Parameters:
    `l` - the specified `Line2D` to test for intersection with the interior of this `Rectangle2D`
  Returns:
    `true` if the specified `Line2D` intersects the interior of this `Rectangle2D`; `false` otherwise.
  Since:
    1.2

### outcode

    public abstract int outcode(double x,
                                double y)

  Determines where the specified coordinates lie with respect to this `Rectangle2D`. This method computes a binary OR of the appropriate mask values indicating, for each side of this `Rectangle2D`, whether or not the specified coordinates are on the same side of the edge as the rest of this `Rectangle2D`.
  Parameters:
    `x, y` - the specified coordinates
  Returns:
    the logical OR of all appropriate out codes.
  Since:
    1.2
  See Also:
    `OUT_LEFT`, `OUT_TOP`, `OUT_RIGHT`, `OUT_BOTTOM`

### outcode

    public int outcode(Point2D p)

  Determines where the specified `Point2D` lies with respect to this `Rectangle2D`. This method computes a binary OR of the appropriate mask values indicating, for each side of this `Rectangle2D`, whether or not the specified `Point2D` is on the same side of the edge as the rest of this `Rectangle2D`.
  Parameters:
    `p` - the specified `Point2D`
  Returns:
    the logical OR of all appropriate out codes.
  Since:
    1.2
  See Also:
    `OUT_LEFT`, `OUT_TOP`, `OUT_RIGHT`, `OUT_BOTTOM`

### setFrame

    public void setFrame(double x,
                         double y,
                         double w,
                         double h)

  Sets the location and size of the outer bounds of this `Rectangle2D` to the specified rectangular values.
  Overrides:
    `setFrame` in class `RectangularShape`
  Parameters:
    `x, y` - the coordinates to which to set the location of the upper left corner of the outer bounds of this `Rectangle2D`
    `w` - the value to use to set the width of the outer bounds of this `Rectangle2D`
    `h` - the value to use to set the height of the outer bounds of this `Rectangle2D`
  Since:
    1.2

### getBounds2D

    public Rectangle2D getBounds2D()

  Returns the high precision bounding box of this `Rectangle2D`.
  Returns:
    the bounding box of this `Rectangle2D`.
  Since:
    1.2

### contains

    public boolean contains(double x,
                            double y)

  Tests if a specified coordinate is inside the boundary of this `Rectangle2D`.
  Parameters:
    `x, y` - the coordinates to test
  Returns:
    `true` if the specified coordinates are inside the boundary of this `Rectangle2D`; `false` otherwise.
  Since:
    1.2

### intersects

    public boolean intersects(double x,
                              double y,
                              double w,
                              double h)

  Tests if the interior of this `Rectangle2D` intersects the interior of a specified set of rectangular coordinates.
  Parameters:
    `x, y` - the coordinates of the upper left corner of the specified set of rectangular coordinates
    `w` - the width of the specified set of rectangular coordinates
    `h` - the height of the specified set of rectangular coordinates
  Returns:
    `true` if this `Rectangle2D` intersects the interior of a specified set of rectangular coordinates; `false` otherwise.
  Since:
    1.2

### contains

    public boolean contains(double x,
                            double y,
                            double w,
                            double h)

  Tests if the interior of this `Rectangle2D` entirely contains the specified set of rectangular coordinates.
  Parameters:
    `x, y` - the coordinates of the upper left corner of the specified set of rectangular coordinates
    `w` - the width of the specified set of rectangular coordinates
    `h` - the height of the specified set of rectangular coordinates
  Returns:
    `true` if this `Rectangle2D` entirely contains specified set of rectangular coordinates; `false` otherwise.
  Since:
    1.2

### createIntersection

    public abstract Rectangle2D createIntersection(Rectangle2D r)

  Returns a new `Rectangle2D` object representing the intersection of this `Rectangle2D` with the specified `Rectangle2D`.
  Parameters:
    `r` - the `Rectangle2D` to be intersected with this `Rectangle2D`
  Returns:
    the largest `Rectangle2D` contained in both the specified `Rectangle2D` and in this `Rectangle2D`.
  Since:
    1.2

### intersect

    public static void intersect(Rectangle2D src1,
                                 Rectangle2D src2,
                                 Rectangle2D dest)

  Intersects the pair of specified source `Rectangle2D` objects and puts the result into the specified destination `Rectangle2D` object.
  Parameters:
    `src1` - the first of a pair of `Rectangle2D` objects to be intersected with each other
    `src2` - the second of a pair of `Rectangle2D` objects to be intersected with each other
    `dest` - the `Rectangle2D` that holds the results of the intersection of `src1` and `src2`
  Since:
    1.2

### createUnion

    public abstract Rectangle2D createUnion(Rectangle2D r)

  Returns a new `Rectangle2D` object representing the union of this `Rectangle2D` with the specified `Rectangle2D`.
  Parameters:
    `r` - the `Rectangle2D` to be combined with this `Rectangle2D`
  Returns:
    the smallest `Rectangle2D` containing both the specified `Rectangle2D` and this `Rectangle2D`.
  Since:
    1.2

### union

    public static void union(Rectangle2D src1,
                             Rectangle2D src2,
                             Rectangle2D dest)

  Unions the pair of source `Rectangle2D` objects and puts the result into the specified destination `Rectangle2D` object.
  Parameters:
    `src1` - the first of a pair of `Rectangle2D` objects to be combined with each other
    `src2` - the second of a pair of `Rectangle2D` objects to be combined with each other
    `dest` - the `Rectangle2D` that holds the results of the union of `src1` and `src2`
  Since:
    1.2

### add

    public void add(double newx,
                    double newy)

  Adds a point, specified by the double precision arguments `newx` and `newy`, to this `Rectangle2D`. The resulting `Rectangle2D` is the smallest `Rectangle2D` that contains both the original `Rectangle2D` and the specified point.

  After adding a point, a call to `contains` with the added point as an argument does not necessarily return `true`. The `contains` method does not return `true` for points on the right or bottom edges of a rectangle. Therefore, if the added point falls on the left or bottom edge of the enlarged rectangle, `contains` returns `false` for that point.

  Parameters:
    `newx, newy` - the coordinates of the new point
  Since:
    JDK1.0

### add

    public void add(Point2D pt)

  Adds the `Point2D` object `pt` to this `Rectangle2D`. The resulting `Rectangle2D` is the smallest `Rectangle2D` that contains both the original `Rectangle2D` and the specified `Point2D`.

  After adding a point, a call to `contains` with the added point as an argument does not necessarily return `true`. The `contains` method does not return `true` for points on the right or bottom edges of a rectangle. Therefore, if the added point falls on the left or bottom edge of the enlarged rectangle, `contains` returns `false` for that point.

  Parameters:
    `pt` - the new `Point2D` to add to this `Rectangle2D`.
  Since:
    JDK1.0

### add

    public void add(Rectangle2D r)

  Adds a `Rectangle2D` object to this `Rectangle2D`. The resulting `Rectangle2D` is the union of the two `Rectangle2D` objects.
  Parameters:
    `r` - the `Rectangle2D` to add to this `Rectangle2D`.
  Since:
    JDK1.0

### getPathIterator

    public PathIterator getPathIterator(AffineTransform at)

  Returns an iteration object that defines the boundary of this `Rectangle2D`. The iterator for this class is multi-threaded safe, which means that this `Rectangle2D` class guarantees that modifications to the geometry of this `Rectangle2D` object do not affect any iterations of that geometry that are already in process.
  Parameters:
    `at` - an optional `AffineTransform` to be applied to the coordinates as they are returned in the iteration, or `null` if untransformed coordinates are desired
  Returns:
    the `PathIterator` object that returns the geometry of the outline of this `Rectangle2D`, one segment at a time.
  Since:
    1.2

### getPathIterator

    public PathIterator getPathIterator(AffineTransform at,
                                        double flatness)

  Returns an iteration object that defines the boundary of the flattened `Rectangle2D`. Since rectangles are already flat, the `flatness` parameter is ignored. The iterator for this class is multi-threaded safe, which means that this `Rectangle2D` class guarantees that modifications to the geometry of this `Rectangle2D` object do not affect any iterations of that geometry that are already in process.
  Overrides:
    `getPathIterator` in class `RectangularShape`
  Parameters:
    `at` - an optional `AffineTransform` to be applied to the coordinates as they are returned in the iteration, or `null` if untransformed coordinates are desired
    `flatness` - the maximum distance that the line segments used to approximate the curved segments are allowed to deviate from any point on the original curve. Since rectangles are already flat, the `flatness` parameter is ignored.
  Returns:
    the `PathIterator` object that returns the geometry of the outline of this `Rectangle2D`, one segment at a time.
  Since:
    1.2

### hashCode

    public int hashCode()

  Returns the hashcode for this `Rectangle2D`.
  Overrides:
    `hashCode` in class `Object`
  Returns:
    the hashcode for this `Rectangle2D`.

### equals

    public boolean equals(Object obj)

  Determines whether or not the specified `Object` is equal to this `Rectangle2D`. The specified `Object` is equal to this `Rectangle2D` if it is an instance of `Rectangle2D` and if its location and size are the same as this `Rectangle2D`.
  Overrides:
    `equals` in class `Object`
  Parameters:
    `obj` - an `Object` to be compared with this `Rectangle2D`.
  Returns:
    `true` if `obj` is an instance of `Rectangle2D` and has the same values; `false` otherwise.
  Since:
    1.2

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.